/*--------------------------------*- C++ -*----------------------------------*\
| =========                 |                                                 |
| \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox           |
|  \\    /   O peration     | Version:  1.7.1                                 |
|   \\  /    A nd           | Web:      www.OpenFOAM.com                      |
|    \\/     M anipulation  |                                                 |
\*---------------------------------------------------------------------------*/
FoamFile
{
    version     2.0;
    `format'      ascii;
    class       dictionary;
    object      blockMeshDict;
}
// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //
// 円管用の blockMesh 作成マクロ （周方向８ブロック分割）
// http://mogura7.zenno.info/~et/xoops/modules/wordpress/index.php?p=408
changecom(//)changequote([,])
define(calc, [esyscmd(perl -e 'print ($1)')])
define(VCOUNT, 0)
define(vlabel, [[// ]Vertex $1 = VCOUNT define($1, VCOUNT)define([VCOUNT], incr(VCOUNT))])
define(pi, 3.14159265)
define(root2, 1.4142135)

// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //

// 円管径
define(R1, 0.032)
define(R2, 0.035)
define(R3, 0.045)

// 円管領域の内部矩形分割領域の比率
define(r, 0.7071)
define(D1, calc(R1 * r))

// 円管の長さ
define(LAB, 0.0234)
// 円管の2段目長さ
define(LBC, 0.00975)
// 円管の3段目長さ
define(LCD, 0.00975)
// 円管の4段目長さ
define(LDE, 0.00975)
// 円管の5段目長さ
define(LEF, 0.018)
// 円管の6段目長さ
define(LFG, 0.01)

// 分割数
//ND 1/8ブロックの周方向
define(ND, 10)
// NR 円管の矩形外領域の径方向
define(NR, 6)
// NR1 円管2層目の径方向
define(NR1, 2)
// NR2 円管3層目の径方向
define(NR2, 5)
// NAB 円管1段目の長手方向 
define(NAB, 10)
// NAB 円管2段目の長手方向 
define(NBC, 4)
// NAB 円管3段目の長手方向 
define(NCD, 4)
// NAB 円管4段目の長手方向 
define(NDE, 4)
// NAB 円管5段目の長手方向 
define(NEF, 8)
// NAB 円管6段目の長手方向 
define(NFG, 4)

// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //

// L 流路位置（Z方向）
define(LA, 0)
define(LB, calc(LA + LAB))
define(LC, calc(LB + LBC))
define(LD, calc(LC + LCD))
define(LE, calc(LD + LDE))
define(LF, calc(LE + LEF))
define(LG, calc(LF + LFG))

define(vert, (x$1$2 y$1$2 $3))
define(dvert, (dx$1$2 dy$1$2 $3))
define(evert, (ex$1$2 ey$1$2 $3))

define(a0, 0)
define(a1, -45)
define(a2, -90)
define(a3, -135)
define(a4, 180)
define(a5, 135)
define(a6, 90)
define(a7, 45)

define(ea0, -22.5)
define(ea1, -67.5)
define(ea2, -112.5)
define(ea3, -157.5)
define(ea4, 157.5)
define(ea5, 112.5)
define(ea6, 67.5)
define(ea7, 22.5)

define(ca0, calc(cos((pi/180)*a0)))
define(ca1, calc(cos((pi/180)*a1)))
define(ca2, calc(cos((pi/180)*a2)))
define(ca3, calc(cos((pi/180)*a3)))
define(ca4, calc(cos((pi/180)*a4)))
define(ca5, calc(cos((pi/180)*a5)))
define(ca6, calc(cos((pi/180)*a6)))
define(ca7, calc(cos((pi/180)*a7)))

define(sa0, calc(sin((pi/180)*a0)))
define(sa1, calc(sin((pi/180)*a1)))
define(sa2, calc(sin((pi/180)*a2)))
define(sa3, calc(sin((pi/180)*a3)))
define(sa4, calc(sin((pi/180)*a4)))
define(sa5, calc(sin((pi/180)*a5)))
define(sa6, calc(sin((pi/180)*a6)))
define(sa7, calc(sin((pi/180)*a7)))

define(cea0, calc(cos((pi/180)*ea0)))
define(cea1, calc(cos((pi/180)*ea1)))
define(cea2, calc(cos((pi/180)*ea2)))
define(cea3, calc(cos((pi/180)*ea3)))
define(cea4, calc(cos((pi/180)*ea4)))
define(cea5, calc(cos((pi/180)*ea5)))
define(cea6, calc(cos((pi/180)*ea6)))
define(cea7, calc(cos((pi/180)*ea7)))

define(sea0, calc(sin((pi/180)*ea0)))
define(sea1, calc(sin((pi/180)*ea1)))
define(sea2, calc(sin((pi/180)*ea2)))
define(sea3, calc(sin((pi/180)*ea3)))
define(sea4, calc(sin((pi/180)*ea4)))
define(sea5, calc(sin((pi/180)*ea5)))
define(sea6, calc(sin((pi/180)*ea6)))
define(sea7, calc(sin((pi/180)*ea7)))

define(x10, calc(R1*ca0))
define(x11, calc(R1*ca1))
define(x12, calc(R1*ca2))
define(x13, calc(R1*ca3))
define(x14, calc(R1*ca4))
define(x15, calc(R1*ca5))
define(x16, calc(R1*ca6))
define(x17, calc(R1*ca7))

define(y10, calc(R1*sa0))
define(y11, calc(R1*sa1))
define(y12, calc(R1*sa2))
define(y13, calc(R1*sa3))
define(y14, calc(R1*sa4))
define(y15, calc(R1*sa5))
define(y16, calc(R1*sa6))
define(y17, calc(R1*sa7))

define(x20, calc(R2*ca0))
define(x21, calc(R2*ca1))
define(x22, calc(R2*ca2))
define(x23, calc(R2*ca3))
define(x24, calc(R2*ca4))
define(x25, calc(R2*ca5))
define(x26, calc(R2*ca6))
define(x27, calc(R2*ca7))

define(y20, calc(R2*sa0))
define(y21, calc(R2*sa1))
define(y22, calc(R2*sa2))
define(y23, calc(R2*sa3))
define(y24, calc(R2*sa4))
define(y25, calc(R2*sa5))
define(y26, calc(R2*sa6))
define(y27, calc(R2*sa7))

define(x30, calc(R3*ca0))
define(x31, calc(R3*ca1))
define(x32, calc(R3*ca2))
define(x33, calc(R3*ca3))
define(x34, calc(R3*ca4))
define(x35, calc(R3*ca5))
define(x36, calc(R3*ca6))
define(x37, calc(R3*ca7))

define(y30, calc(R3*sa0))
define(y31, calc(R3*sa1))
define(y32, calc(R3*sa2))
define(y33, calc(R3*sa3))
define(y34, calc(R3*sa4))
define(y35, calc(R3*sa5))
define(y36, calc(R3*sa6))
define(y37, calc(R3*sa7))

define(dx10, calc(D1*ca0))
define(dx11, calc(D1*ca1))
define(dx12, calc(D1*ca2))
define(dx13, calc(D1*ca3))
define(dx14, calc(D1*ca4))
define(dx15, calc(D1*ca5))
define(dx16, calc(D1*ca6))
define(dx17, calc(D1*ca7))

define(dy10, calc(D1*sa0))
define(dy11, calc(D1*sa1))
define(dy12, calc(D1*sa2))
define(dy13, calc(D1*sa3))
define(dy14, calc(D1*sa4))
define(dy15, calc(D1*sa5))
define(dy16, calc(D1*sa6))
define(dy17, calc(D1*sa7))

define(ex10, calc(R1*cea0))
define(ex11, calc(R1*cea1))
define(ex12, calc(R1*cea2))
define(ex13, calc(R1*cea3))
define(ex14, calc(R1*cea4))
define(ex15, calc(R1*cea5))
define(ex16, calc(R1*cea6))
define(ex17, calc(R1*cea7))

define(ey10, calc(R1*sea0))
define(ey11, calc(R1*sea1))
define(ey12, calc(R1*sea2))
define(ey13, calc(R1*sea3))
define(ey14, calc(R1*sea4))
define(ey15, calc(R1*sea5))
define(ey16, calc(R1*sea6))
define(ey17, calc(R1*sea7))

define(ex20, calc(R2*cea0))
define(ex21, calc(R2*cea1))
define(ex22, calc(R2*cea2))
define(ex23, calc(R2*cea3))
define(ex24, calc(R2*cea4))
define(ex25, calc(R2*cea5))
define(ex26, calc(R2*cea6))
define(ex27, calc(R2*cea7))

define(ey20, calc(R2*sea0))
define(ey21, calc(R2*sea1))
define(ey22, calc(R2*sea2))
define(ey23, calc(R2*sea3))
define(ey24, calc(R2*sea4))
define(ey25, calc(R2*sea5))
define(ey26, calc(R2*sea6))
define(ey27, calc(R2*sea7))

define(ex30, calc(R3*cea0))
define(ex31, calc(R3*cea1))
define(ex32, calc(R3*cea2))
define(ex33, calc(R3*cea3))
define(ex34, calc(R3*cea4))
define(ex35, calc(R3*cea5))
define(ex36, calc(R3*cea6))
define(ex37, calc(R3*cea7))

define(ey30, calc(R3*sea0))
define(ey31, calc(R3*sea1))
define(ey32, calc(R3*sea2))
define(ey33, calc(R3*sea3))
define(ey34, calc(R3*sea4))
define(ey35, calc(R3*sea5))
define(ey36, calc(R3*sea6))
define(ey37, calc(R3*sea7))
// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //
convertToMeters 1;

vertices
(

    ( 0.0 0.0 LA) vlabel(GA)

    dvert(1, 0, LA) vlabel(DA0)
    dvert(1, 1, LA) vlabel(DA1)
    dvert(1, 2, LA) vlabel(DA2)
    dvert(1, 3, LA) vlabel(DA3)
    dvert(1, 4, LA) vlabel(DA4)
    dvert(1, 5, LA) vlabel(DA5)
    dvert(1, 6, LA) vlabel(DA6)
    dvert(1, 7, LA) vlabel(DA7)
    vert(1, 0, LA) vlabel(RA0)
    vert(1, 1, LA) vlabel(RA1)
    vert(1, 2, LA) vlabel(RA2)
    vert(1, 3, LA) vlabel(RA3)
    vert(1, 4, LA) vlabel(RA4)
    vert(1, 5, LA) vlabel(RA5)
    vert(1, 6, LA) vlabel(RA6)
    vert(1, 7, LA) vlabel(RA7)
    vert(2, 0, LA) vlabel(R1A0)
    vert(2, 1, LA) vlabel(R1A1)
    vert(2, 2, LA) vlabel(R1A2)
    vert(2, 3, LA) vlabel(R1A3)
    vert(2, 4, LA) vlabel(R1A4)
    vert(2, 5, LA) vlabel(R1A5)
    vert(2, 6, LA) vlabel(R1A6)
    vert(2, 7, LA) vlabel(R1A7)
    vert(3, 0, LA) vlabel(R2A0)
    vert(3, 1, LA) vlabel(R2A1)
    vert(3, 2, LA) vlabel(R2A2)
    vert(3, 3, LA) vlabel(R2A3)
    vert(3, 4, LA) vlabel(R2A4)
    vert(3, 5, LA) vlabel(R2A5)
    vert(3, 6, LA) vlabel(R2A6)
    vert(3, 7, LA) vlabel(R2A7)

    ( 0.0 0.0 LB) vlabel(GB)

    dvert(1, 0, LB) vlabel(DB0)
    dvert(1, 1, LB) vlabel(DB1)
    dvert(1, 2, LB) vlabel(DB2)
    dvert(1, 3, LB) vlabel(DB3)
    dvert(1, 4, LB) vlabel(DB4)
    dvert(1, 5, LB) vlabel(DB5)
    dvert(1, 6, LB) vlabel(DB6)
    dvert(1, 7, LB) vlabel(DB7)
    vert(1, 0, LB) vlabel(RB0)
    vert(1, 1, LB) vlabel(RB1)
    vert(1, 2, LB) vlabel(RB2)
    vert(1, 3, LB) vlabel(RB3)
    vert(1, 4, LB) vlabel(RB4)
    vert(1, 5, LB) vlabel(RB5)
    vert(1, 6, LB) vlabel(RB6)
    vert(1, 7, LB) vlabel(RB7)
    vert(2, 0, LB) vlabel(R1B0)
    vert(2, 1, LB) vlabel(R1B1)
    vert(2, 2, LB) vlabel(R1B2)
    vert(2, 3, LB) vlabel(R1B3)
    vert(2, 4, LB) vlabel(R1B4)
    vert(2, 5, LB) vlabel(R1B5)
    vert(2, 6, LB) vlabel(R1B6)
    vert(2, 7, LB) vlabel(R1B7)
    vert(3, 0, LB) vlabel(R2B0)
    vert(3, 1, LB) vlabel(R2B1)
    vert(3, 2, LB) vlabel(R2B2)
    vert(3, 3, LB) vlabel(R2B3)
    vert(3, 4, LB) vlabel(R2B4)
    vert(3, 5, LB) vlabel(R2B5)
    vert(3, 6, LB) vlabel(R2B6)
    vert(3, 7, LB) vlabel(R2B7)

    ( 0.0 0.0 LC) vlabel(GC)

    dvert(1, 0, LC) vlabel(DC0)
    dvert(1, 1, LC) vlabel(DC1)
    dvert(1, 2, LC) vlabel(DC2)
    dvert(1, 3, LC) vlabel(DC3)
    dvert(1, 4, LC) vlabel(DC4)
    dvert(1, 5, LC) vlabel(DC5)
    dvert(1, 6, LC) vlabel(DC6)
    dvert(1, 7, LC) vlabel(DC7)
    vert(1, 0, LC) vlabel(RC0)
    vert(1, 1, LC) vlabel(RC1)
    vert(1, 2, LC) vlabel(RC2)
    vert(1, 3, LC) vlabel(RC3)
    vert(1, 4, LC) vlabel(RC4)
    vert(1, 5, LC) vlabel(RC5)
    vert(1, 6, LC) vlabel(RC6)
    vert(1, 7, LC) vlabel(RC7)
    vert(2, 0, LC) vlabel(R1C0)
    vert(2, 1, LC) vlabel(R1C1)
    vert(2, 2, LC) vlabel(R1C2)
    vert(2, 3, LC) vlabel(R1C3)
    vert(2, 4, LC) vlabel(R1C4)
    vert(2, 5, LC) vlabel(R1C5)
    vert(2, 6, LC) vlabel(R1C6)
    vert(2, 7, LC) vlabel(R1C7)
    vert(3, 0, LC) vlabel(R2C0)
    vert(3, 1, LC) vlabel(R2C1)
    vert(3, 2, LC) vlabel(R2C2)
    vert(3, 3, LC) vlabel(R2C3)
    vert(3, 4, LC) vlabel(R2C4)
    vert(3, 5, LC) vlabel(R2C5)
    vert(3, 6, LC) vlabel(R2C6)
    vert(3, 7, LC) vlabel(R2C7)

    ( 0.0 0.0 LD) vlabel(GD)

    dvert(1, 0, LD) vlabel(DD0)
    dvert(1, 1, LD) vlabel(DD1)
    dvert(1, 2, LD) vlabel(DD2)
    dvert(1, 3, LD) vlabel(DD3)
    dvert(1, 4, LD) vlabel(DD4)
    dvert(1, 5, LD) vlabel(DD5)
    dvert(1, 6, LD) vlabel(DD6)
    dvert(1, 7, LD) vlabel(DD7)
    vert(1, 0, LD) vlabel(RD0)
    vert(1, 1, LD) vlabel(RD1)
    vert(1, 2, LD) vlabel(RD2)
    vert(1, 3, LD) vlabel(RD3)
    vert(1, 4, LD) vlabel(RD4)
    vert(1, 5, LD) vlabel(RD5)
    vert(1, 6, LD) vlabel(RD6)
    vert(1, 7, LD) vlabel(RD7)
    vert(2, 0, LD) vlabel(R1D0)
    vert(2, 1, LD) vlabel(R1D1)
    vert(2, 2, LD) vlabel(R1D2)
    vert(2, 3, LD) vlabel(R1D3)
    vert(2, 4, LD) vlabel(R1D4)
    vert(2, 5, LD) vlabel(R1D5)
    vert(2, 6, LD) vlabel(R1D6)
    vert(2, 7, LD) vlabel(R1D7)
    vert(3, 0, LD) vlabel(R2D0)
    vert(3, 1, LD) vlabel(R2D1)
    vert(3, 2, LD) vlabel(R2D2)
    vert(3, 3, LD) vlabel(R2D3)
    vert(3, 4, LD) vlabel(R2D4)
    vert(3, 5, LD) vlabel(R2D5)
    vert(3, 6, LD) vlabel(R2D6)
    vert(3, 7, LD) vlabel(R2D7)

    ( 0.0 0.0 LE) vlabel(GE)

    dvert(1, 0, LE) vlabel(DE0)
    dvert(1, 1, LE) vlabel(DE1)
    dvert(1, 2, LE) vlabel(DE2)
    dvert(1, 3, LE) vlabel(DE3)
    dvert(1, 4, LE) vlabel(DE4)
    dvert(1, 5, LE) vlabel(DE5)
    dvert(1, 6, LE) vlabel(DE6)
    dvert(1, 7, LE) vlabel(DE7)
    vert(1, 0, LE) vlabel(RE0)
    vert(1, 1, LE) vlabel(RE1)
    vert(1, 2, LE) vlabel(RE2)
    vert(1, 3, LE) vlabel(RE3)
    vert(1, 4, LE) vlabel(RE4)
    vert(1, 5, LE) vlabel(RE5)
    vert(1, 6, LE) vlabel(RE6)
    vert(1, 7, LE) vlabel(RE7)
    vert(2, 0, LE) vlabel(R1E0)
    vert(2, 1, LE) vlabel(R1E1)
    vert(2, 2, LE) vlabel(R1E2)
    vert(2, 3, LE) vlabel(R1E3)
    vert(2, 4, LE) vlabel(R1E4)
    vert(2, 5, LE) vlabel(R1E5)
    vert(2, 6, LE) vlabel(R1E6)
    vert(2, 7, LE) vlabel(R1E7)
    vert(3, 0, LE) vlabel(R2E0)
    vert(3, 1, LE) vlabel(R2E1)
    vert(3, 2, LE) vlabel(R2E2)
    vert(3, 3, LE) vlabel(R2E3)
    vert(3, 4, LE) vlabel(R2E4)
    vert(3, 5, LE) vlabel(R2E5)
    vert(3, 6, LE) vlabel(R2E6)
    vert(3, 7, LE) vlabel(R2E7)

    ( 0.0 0.0 LF) vlabel(GF)

    dvert(1, 0, LF) vlabel(DF0)
    dvert(1, 1, LF) vlabel(DF1)
    dvert(1, 2, LF) vlabel(DF2)
    dvert(1, 3, LF) vlabel(DF3)
    dvert(1, 4, LF) vlabel(DF4)
    dvert(1, 5, LF) vlabel(DF5)
    dvert(1, 6, LF) vlabel(DF6)
    dvert(1, 7, LF) vlabel(DF7)
    vert(1, 0, LF) vlabel(RF0)
    vert(1, 1, LF) vlabel(RF1)
    vert(1, 2, LF) vlabel(RF2)
    vert(1, 3, LF) vlabel(RF3)
    vert(1, 4, LF) vlabel(RF4)
    vert(1, 5, LF) vlabel(RF5)
    vert(1, 6, LF) vlabel(RF6)
    vert(1, 7, LF) vlabel(RF7)
    vert(2, 0, LF) vlabel(R1F0)
    vert(2, 1, LF) vlabel(R1F1)
    vert(2, 2, LF) vlabel(R1F2)
    vert(2, 3, LF) vlabel(R1F3)
    vert(2, 4, LF) vlabel(R1F4)
    vert(2, 5, LF) vlabel(R1F5)
    vert(2, 6, LF) vlabel(R1F6)
    vert(2, 7, LF) vlabel(R1F7)
    vert(3, 0, LF) vlabel(R2F0)
    vert(3, 1, LF) vlabel(R2F1)
    vert(3, 2, LF) vlabel(R2F2)
    vert(3, 3, LF) vlabel(R2F3)
    vert(3, 4, LF) vlabel(R2F4)
    vert(3, 5, LF) vlabel(R2F5)
    vert(3, 6, LF) vlabel(R2F6)
    vert(3, 7, LF) vlabel(R2F7)

    ( 0.0 0.0 LG) vlabel(GG)

    dvert(1, 0, LG) vlabel(DG0)
    dvert(1, 1, LG) vlabel(DG1)
    dvert(1, 2, LG) vlabel(DG2)
    dvert(1, 3, LG) vlabel(DG3)
    dvert(1, 4, LG) vlabel(DG4)
    dvert(1, 5, LG) vlabel(DG5)
    dvert(1, 6, LG) vlabel(DG6)
    dvert(1, 7, LG) vlabel(DG7)
    vert(1, 0, LG) vlabel(RG0)
    vert(1, 1, LG) vlabel(RG1)
    vert(1, 2, LG) vlabel(RG2)
    vert(1, 3, LG) vlabel(RG3)
    vert(1, 4, LG) vlabel(RG4)
    vert(1, 5, LG) vlabel(RG5)
    vert(1, 6, LG) vlabel(RG6)
    vert(1, 7, LG) vlabel(RG7)
    vert(2, 0, LG) vlabel(R1G0)
    vert(2, 1, LG) vlabel(R1G1)
    vert(2, 2, LG) vlabel(R1G2)
    vert(2, 3, LG) vlabel(R1G3)
    vert(2, 4, LG) vlabel(R1G4)
    vert(2, 5, LG) vlabel(R1G5)
    vert(2, 6, LG) vlabel(R1G6)
    vert(2, 7, LG) vlabel(R1G7)
    vert(3, 0, LG) vlabel(R2G0)
    vert(3, 1, LG) vlabel(R2G1)
    vert(3, 2, LG) vlabel(R2G2)
    vert(3, 3, LG) vlabel(R2G3)
    vert(3, 4, LG) vlabel(R2G4)
    vert(3, 5, LG) vlabel(R2G5)
    vert(3, 6, LG) vlabel(R2G6)
    vert(3, 7, LG) vlabel(R2G7)
);

blocks
(

// NAB 円管 
    // 中心矩形領域（４分割）
    hex (DA0 GA DA2 DA1 DB0 GB DB2 DB1)
    rotating
    (ND ND NAB)
    simpleGrading (1 1 1) 
    hex (DA2 GA DA4 DA3 DB2 GB DB4 DB3)
    rotating
    (ND ND NAB)
    simpleGrading (1 1 1)
    hex (DA4 GA DA6 DA5 DB4 GB DB6 DB5)
    rotating
    (ND ND NAB)
    simpleGrading (1 1 1)
    hex (DA6 GA DA0 DA7 DB6 GB DB0 DB7)
    rotating
    (ND ND NAB)
    simpleGrading (1 1 1)

    // block0
    hex (DA0 DA1 RA1 RA0 DB0 DB1 RB1 RB0)
    rotating
    (ND NR NAB)
    simpleGrading (1 1 1)
    // block1
    hex (DA1 DA2 RA2 RA1 DB1 DB2 RB2 RB1)
    rotating
    (ND NR NAB)
    simpleGrading (1 1 1)
    // block2
    hex (DA2 DA3 RA3 RA2 DB2 DB3 RB3 RB2)
    rotating
    (ND NR NAB)
    simpleGrading (1 1 1)
    // block3
    hex (DA3 DA4 RA4 RA3 DB3 DB4 RB4 RB3)
    rotating
    (ND NR NAB)
    simpleGrading (1 1 1)
    // block3
    hex (DA4 DA5 RA5 RA4 DB4 DB5 RB5 RB4)
    rotating
    (ND NR NAB)
    simpleGrading (1 1 1)
    // block3
    hex (DA5 DA6 RA6 RA5 DB5 DB6 RB6 RB5)
    rotating
    (ND NR NAB)
    simpleGrading (1 1 1)
    // block3
    hex (DA6 DA7 RA7 RA6 DB6 DB7 RB7 RB6)
    rotating
    (ND NR NAB)
    simpleGrading (1 1 1)
    // block3
    hex (DA7 DA0 RA0 RA7 DB7 DB0 RB0 RB7)
    rotating
    (ND NR NAB)
    simpleGrading (1 1 1)

    // block0 (D->R, R->R1, NR->NR1)
    hex (RA0 RA1 R1A1 R1A0 RB0 RB1 R1B1 R1B0)
    rotating
    (ND NR1 NAB)
    simpleGrading (1 1 1)
    // block1
    hex (RA1 RA2 R1A2 R1A1 RB1 RB2 R1B2 R1B1)
    rotating
    (ND NR1 NAB)
    simpleGrading (1 1 1)
    // block2
    hex (RA2 RA3 R1A3 R1A2 RB2 RB3 R1B3 R1B2)
    rotating
    (ND NR1 NAB)
    simpleGrading (1 1 1)
    // block3
    hex (RA3 RA4 R1A4 R1A3 RB3 RB4 R1B4 R1B3)
    rotating
    (ND NR1 NAB)
    simpleGrading (1 1 1)
    // block3
    hex (RA4 RA5 R1A5 R1A4 RB4 RB5 R1B5 R1B4)
    rotating
    (ND NR1 NAB)
    simpleGrading (1 1 1)
    // block3
    hex (RA5 RA6 R1A6 R1A5 RB5 RB6 R1B6 R1B5)
    rotating
    (ND NR1 NAB)
    simpleGrading (1 1 1)
    // block3
    hex (RA6 RA7 R1A7 R1A6 RB6 RB7 R1B7 R1B6)
    rotating
    (ND NR1 NAB)
    simpleGrading (1 1 1)
    // block3
    hex (RA7 RA0 R1A0 R1A7 RB7 RB0 R1B0 R1B7)
    rotating
    (ND NR1 NAB)
    simpleGrading (1 1 1)

    // block0 (R->R1, R1->R2, NR1->NR2)
    hex (R1A0 R1A1 R2A1 R2A0 R1B0 R1B1 R2B1 R2B0)
    (ND NR2 NAB)
    simpleGrading (1 1 1)
    // block1
    hex (R1A1 R1A2 R2A2 R2A1 R1B1 R1B2 R2B2 R2B1)
    (ND NR2 NAB)
    simpleGrading (1 1 1)
    // block2
    hex (R1A2 R1A3 R2A3 R2A2 R1B2 R1B3 R2B3 R2B2)
    (ND NR2 NAB)
    simpleGrading (1 1 1)
    // block3
    hex (R1A3 R1A4 R2A4 R2A3 R1B3 R1B4 R2B4 R2B3)
    (ND NR2 NAB)
    simpleGrading (1 1 1)
    // block3
    hex (R1A4 R1A5 R2A5 R2A4 R1B4 R1B5 R2B5 R2B4)
    (ND NR2 NAB)
    simpleGrading (1 1 1)
    // block3
    hex (R1A5 R1A6 R2A6 R2A5 R1B5 R1B6 R2B6 R2B5)
    (ND NR2 NAB)
    simpleGrading (1 1 1)
    // block3
    hex (R1A6 R1A7 R2A7 R2A6 R1B6 R1B7 R2B7 R2B6)
    (ND NR2 NAB)
    simpleGrading (1 1 1)
    // block3
    hex (R1A7 R1A0 R2A0 R2A7 R1B7 R1B0 R2B0 R2B7)
    (ND NR2 NAB)
    simpleGrading (1 1 1)

// NBC 円管2段目 ( A->B, B->C, AB->BC ) 
    // 中心矩形領域（４分割）
    hex (DB0 GB DB2 DB1 DC0 GC DC2 DC1)
    rotating
    (ND ND NBC)
    simpleGrading (1 1 1)
    hex (DB2 GB DB4 DB3 DC2 GC DC4 DC3)
    rotating
    (ND ND NBC)
    simpleGrading (1 1 1)
    hex (DB4 GB DB6 DB5 DC4 GC DC6 DC5)
    rotating
    (ND ND NBC)
    simpleGrading (1 1 1)
    hex (DB6 GB DB0 DB7 DC6 GC DC0 DC7)
    rotating
    (ND ND NBC)
    simpleGrading (1 1 1)

    // block0
    hex (DB0 DB1 RB1 RB0 DC0 DC1 RC1 RC0)
    rotating
    (ND NR NBC)
    simpleGrading (1 1 1)
    // block1
    hex (DB1 DB2 RB2 RB1 DC1 DC2 RC2 RC1)
    rotating
    (ND NR NBC)
    simpleGrading (1 1 1)
    // block2
    hex (DB2 DB3 RB3 RB2 DC2 DC3 RC3 RC2)
    rotating
    (ND NR NBC)
    simpleGrading (1 1 1)
    // block3
    hex (DB3 DB4 RB4 RB3 DC3 DC4 RC4 RC3)
    rotating
    (ND NR NBC)
    simpleGrading (1 1 1)
    // block3
    hex (DB4 DB5 RB5 RB4 DC4 DC5 RC5 RC4)
    rotating
    (ND NR NBC)
    simpleGrading (1 1 1)
    // block3
    hex (DB5 DB6 RB6 RB5 DC5 DC6 RC6 RC5)
    rotating
    (ND NR NBC)
    simpleGrading (1 1 1)
    // block3
    hex (DB6 DB7 RB7 RB6 DC6 DC7 RC7 RC6)
    rotating
    (ND NR NBC)
    simpleGrading (1 1 1)
    // block3
    hex (DB7 DB0 RB0 RB7 DC7 DC0 RC0 RC7)
    rotating
    (ND NR NBC)
    simpleGrading (1 1 1)

    // block0 (D->R, R->R1, NR->NR1)
    hex (RB0 RB1 R1B1 R1B0 RC0 RC1 R1C1 R1C0)
    (ND NR1 NBC)
    simpleGrading (1 1 1)
    // block1
    hex (RB1 RB2 R1B2 R1B1 RC1 RC2 R1C2 R1C1)
    (ND NR1 NBC)
    simpleGrading (1 1 1)
    // block2
    hex (RB2 RB3 R1B3 R1B2 RC2 RC3 R1C3 R1C2)
    (ND NR1 NBC)
    simpleGrading (1 1 1)
    // block3
    hex (RB3 RB4 R1B4 R1B3 RC3 RC4 R1C4 R1C3)
    (ND NR1 NBC)
    simpleGrading (1 1 1)
    // block3
    hex (RB4 RB5 R1B5 R1B4 RC4 RC5 R1C5 R1C4)
    (ND NR1 NBC)
    simpleGrading (1 1 1)
    // block3
    hex (RB5 RB6 R1B6 R1B5 RC5 RC6 R1C6 R1C5)
    (ND NR1 NBC)
    simpleGrading (1 1 1)
    // block3
    hex (RB6 RB7 R1B7 R1B6 RC6 RC7 R1C7 R1C6)
    (ND NR1 NBC)
    simpleGrading (1 1 1)
    // block3
    hex (RB7 RB0 R1B0 R1B7 RC7 RC0 R1C0 R1C7)
    (ND NR1 NBC)
    simpleGrading (1 1 1)

    // block0 (R->R1, R1->R2, NR1->NR2)
    hex (R1B0 R1B1 R2B1 R2B0 R1C0 R1C1 R2C1 R2C0)
    (ND NR2 NBC)
    simpleGrading (1 1 1)
    // block1
    hex (R1B1 R1B2 R2B2 R2B1 R1C1 R1C2 R2C2 R2C1)
    (ND NR2 NBC)
    simpleGrading (1 1 1)
    // block2
    hex (R1B2 R1B3 R2B3 R2B2 R1C2 R1C3 R2C3 R2C2)
    (ND NR2 NBC)
    simpleGrading (1 1 1)
    // block3
    hex (R1B3 R1B4 R2B4 R2B3 R1C3 R1C4 R2C4 R2C3)
    (ND NR2 NBC)
    simpleGrading (1 1 1)
    // block3
    hex (R1B4 R1B5 R2B5 R2B4 R1C4 R1C5 R2C5 R2C4)
    (ND NR2 NBC)
    simpleGrading (1 1 1)
    // block3
    hex (R1B5 R1B6 R2B6 R2B5 R1C5 R1C6 R2C6 R2C5)
    (ND NR2 NBC)
    simpleGrading (1 1 1)
    // block3
    hex (R1B6 R1B7 R2B7 R2B6 R1C6 R1C7 R2C7 R2C6)
    (ND NR2 NBC)
    simpleGrading (1 1 1)
    // block3
    hex (R1B7 R1B0 R2B0 R2B7 R1C7 R1C0 R2C0 R2C7)
    (ND NR2 NBC)
    simpleGrading (1 1 1)

// NCD 円管3段目 ( B->C, C->D, BC->CD ) 
    // 中心矩形領域（４分割）
    hex (DC0 GC DC2 DC1 DD0 GD DD2 DD1)
    rotating
    (ND ND NCD)
    simpleGrading (1 1 1)
    hex (DC2 GC DC4 DC3 DD2 GD DD4 DD3)
    rotating
    (ND ND NCD)
    simpleGrading (1 1 1)
    hex (DC4 GC DC6 DC5 DD4 GD DD6 DD5)
    rotating
    (ND ND NCD)
    simpleGrading (1 1 1)
    hex (DC6 GC DC0 DC7 DD6 GD DD0 DD7)
    rotating
    (ND ND NCD)
    simpleGrading (1 1 1)

    // block0
    hex (DC0 DC1 RC1 RC0 DD0 DD1 RD1 RD0)
    rotating
    (ND NR NCD)
    simpleGrading (1 1 1)
    // block1
    hex (DC1 DC2 RC2 RC1 DD1 DD2 RD2 RD1)
    rotating
    (ND NR NCD)
    simpleGrading (1 1 1)
    // block2
    hex (DC2 DC3 RC3 RC2 DD2 DD3 RD3 RD2)
    rotating
    (ND NR NCD)
    simpleGrading (1 1 1)
    // block3
    hex (DC3 DC4 RC4 RC3 DD3 DD4 RD4 RD3)
    rotating
    (ND NR NCD)
    simpleGrading (1 1 1)
    // block3
    hex (DC4 DC5 RC5 RC4 DD4 DD5 RD5 RD4)
    rotating
    (ND NR NCD)
    simpleGrading (1 1 1)
    // block3
    hex (DC5 DC6 RC6 RC5 DD5 DD6 RD6 RD5)
    rotating
    (ND NR NCD)
    simpleGrading (1 1 1)
    // block3
    hex (DC6 DC7 RC7 RC6 DD6 DD7 RD7 RD6)
    rotating
    (ND NR NCD)
    simpleGrading (1 1 1)
    // block3
    hex (DC7 DC0 RC0 RC7 DD7 DD0 RD0 RD7)
    rotating
    (ND NR NCD)
    simpleGrading (1 1 1)

    // block0 (D->R, R->R1, NR->NR1)
    hex (RC0 RC1 R1C1 R1C0 RD0 RD1 R1D1 R1D0)
    rotating
    (ND NR1 NCD)
    simpleGrading (1 1 1)
    // block1
    hex (RC1 RC2 R1C2 R1C1 RD1 RD2 R1D2 R1D1)
    rotating
    (ND NR1 NCD)
    simpleGrading (1 1 1)
    // block2
    hex (RC2 RC3 R1C3 R1C2 RD2 RD3 R1D3 R1D2)
    rotating
    (ND NR1 NCD)
    simpleGrading (1 1 1)
    // block3
    hex (RC3 RC4 R1C4 R1C3 RD3 RD4 R1D4 R1D3)
    rotating
    (ND NR1 NCD)
    simpleGrading (1 1 1)
    // block3
    hex (RC4 RC5 R1C5 R1C4 RD4 RD5 R1D5 R1D4)
    rotating
    (ND NR1 NCD)
    simpleGrading (1 1 1)
    // block3
    hex (RC5 RC6 R1C6 R1C5 RD5 RD6 R1D6 R1D5)
    rotating
    (ND NR1 NCD)
    simpleGrading (1 1 1)
    // block3
    hex (RC6 RC7 R1C7 R1C6 RD6 RD7 R1D7 R1D6)
    rotating
    (ND NR1 NCD)
    simpleGrading (1 1 1)
    // block3
    hex (RC7 RC0 R1C0 R1C7 RD7 RD0 R1D0 R1D7)
    rotating
    (ND NR1 NCD)
    simpleGrading (1 1 1)

    // block0 (R->R1, R1->R2, NR1->NR2)
    hex (R1C0 R1C1 R2C1 R2C0 R1D0 R1D1 R2D1 R2D0)
    (ND NR2 NCD)
    simpleGrading (1 1 1)
    // block1
    hex (R1C1 R1C2 R2C2 R2C1 R1D1 R1D2 R2D2 R2D1)
    (ND NR2 NCD)
    simpleGrading (1 1 1)
    // block2
    hex (R1C2 R1C3 R2C3 R2C2 R1D2 R1D3 R2D3 R2D2)
    (ND NR2 NCD)
    simpleGrading (1 1 1)
    // block3
    hex (R1C3 R1C4 R2C4 R2C3 R1D3 R1D4 R2D4 R2D3)
    (ND NR2 NCD)
    simpleGrading (1 1 1)
    // block3
    hex (R1C4 R1C5 R2C5 R2C4 R1D4 R1D5 R2D5 R2D4)
    (ND NR2 NCD)
    simpleGrading (1 1 1)
    // block3
    hex (R1C5 R1C6 R2C6 R2C5 R1D5 R1D6 R2D6 R2D5)
    (ND NR2 NCD)
    simpleGrading (1 1 1)
    // block3
    hex (R1C6 R1C7 R2C7 R2C6 R1D6 R1D7 R2D7 R2D6)
    (ND NR2 NCD)
    simpleGrading (1 1 1)
    // block3
    hex (R1C7 R1C0 R2C0 R2C7 R1D7 R1D0 R2D0 R2D7)
    (ND NR2 NCD)
    simpleGrading (1 1 1)

// NDE 円管4段目 ( C->D, D->E, CD->DE ) 
    // 中心矩形領域（４分割）
    hex (DD0 GD DD2 DD1 DE0 GE DE2 DE1)
    rotating
    (ND ND NDE)
    simpleGrading (1 1 1)
    hex (DD2 GD DD4 DD3 DE2 GE DE4 DE3)
    rotating
    (ND ND NDE)
    simpleGrading (1 1 1)
    hex (DD4 GD DD6 DD5 DE4 GE DE6 DE5)
    rotating
    (ND ND NDE)
    simpleGrading (1 1 1)
    hex (DD6 GD DD0 DD7 DE6 GE DE0 DE7)
    rotating
    (ND ND NDE)
    simpleGrading (1 1 1)

    // block0
    hex (DD0 DD1 RD1 RD0 DE0 DE1 RE1 RE0)
    rotating
    (ND NR NDE)
    simpleGrading (1 1 1)
    // block1
    hex (DD1 DD2 RD2 RD1 DE1 DE2 RE2 RE1)
    rotating
    (ND NR NDE)
    simpleGrading (1 1 1)
    // block2
    hex (DD2 DD3 RD3 RD2 DE2 DE3 RE3 RE2)
    rotating
    (ND NR NDE)
    simpleGrading (1 1 1)
    // block3
    hex (DD3 DD4 RD4 RD3 DE3 DE4 RE4 RE3)
    rotating
    (ND NR NDE)
    simpleGrading (1 1 1)
    // block3
    hex (DD4 DD5 RD5 RD4 DE4 DE5 RE5 RE4)
    rotating
    (ND NR NDE)
    simpleGrading (1 1 1)
    // block3
    hex (DD5 DD6 RD6 RD5 DE5 DE6 RE6 RE5)
    rotating
    (ND NR NDE)
    simpleGrading (1 1 1)
    // block3
    hex (DD6 DD7 RD7 RD6 DE6 DE7 RE7 RE6)
    rotating
    (ND NR NDE)
    simpleGrading (1 1 1)
    // block3
    hex (DD7 DD0 RD0 RD7 DE7 DE0 RE0 RE7)
    rotating
    (ND NR NDE)
    simpleGrading (1 1 1)

    // block0 (D->R, R->R1, NR->NR1)
    hex (RD0 RD1 R1D1 R1D0 RE0 RE1 R1E1 R1E0)
    (ND NR1 NDE)
    simpleGrading (1 1 1)
    // block1
    hex (RD1 RD2 R1D2 R1D1 RE1 RE2 R1E2 R1E1)
    (ND NR1 NDE)
    simpleGrading (1 1 1)
    // block2
    hex (RD2 RD3 R1D3 R1D2 RE2 RE3 R1E3 R1E2)
    (ND NR1 NDE)
    simpleGrading (1 1 1)
    // block3
    hex (RD3 RD4 R1D4 R1D3 RE3 RE4 R1E4 R1E3)
    (ND NR1 NDE)
    simpleGrading (1 1 1)
    // block3
    hex (RD4 RD5 R1D5 R1D4 RE4 RE5 R1E5 R1E4)
    (ND NR1 NDE)
    simpleGrading (1 1 1)
    // block3
    hex (RD5 RD6 R1D6 R1D5 RE5 RE6 R1E6 R1E5)
    (ND NR1 NDE)
    simpleGrading (1 1 1)
    // block3
    hex (RD6 RD7 R1D7 R1D6 RE6 RE7 R1E7 R1E6)
    (ND NR1 NDE)
    simpleGrading (1 1 1)
    // block3
    hex (RD7 RD0 R1D0 R1D7 RE7 RE0 R1E0 R1E7)
    (ND NR1 NDE)
    simpleGrading (1 1 1)

    // block0 (R->R1, R1->R2, NR1->NR2)
    hex (R1D0 R1D1 R2D1 R2D0 R1E0 R1E1 R2E1 R2E0)
    (ND NR2 NDE)
    simpleGrading (1 1 1)
    // block1
    hex (R1D1 R1D2 R2D2 R2D1 R1E1 R1E2 R2E2 R2E1)
    (ND NR2 NDE)
    simpleGrading (1 1 1)
    // block2
    hex (R1D2 R1D3 R2D3 R2D2 R1E2 R1E3 R2E3 R2E2)
    (ND NR2 NDE)
    simpleGrading (1 1 1)
    // block3
    hex (R1D3 R1D4 R2D4 R2D3 R1E3 R1E4 R2E4 R2E3)
    (ND NR2 NDE)
    simpleGrading (1 1 1)
    // block3
    hex (R1D4 R1D5 R2D5 R2D4 R1E4 R1E5 R2E5 R2E4)
    (ND NR2 NDE)
    simpleGrading (1 1 1)
    // block3
    hex (R1D5 R1D6 R2D6 R2D5 R1E5 R1E6 R2E6 R2E5)
    (ND NR2 NDE)
    simpleGrading (1 1 1)
    // block3
    hex (R1D6 R1D7 R2D7 R2D6 R1E6 R1E7 R2E7 R2E6)
    (ND NR2 NDE)
    simpleGrading (1 1 1)
    // block3
    hex (R1D7 R1D0 R2D0 R2D7 R1E7 R1E0 R2E0 R2E7)
    (ND NR2 NDE)
    simpleGrading (1 1 1)

// NEF 円管5段目 ( D->E, E->F, DF->EF ) 
    // 中心矩形領域（４分割）
    hex (DE0 GE DE2 DE1 DF0 GF DF2 DF1)
    rotating
    (ND ND NEF)
    simpleGrading (1 1 1)
    hex (DE2 GE DE4 DE3 DF2 GF DF4 DF3)
    rotating
    (ND ND NEF)
    simpleGrading (1 1 1)
    hex (DE4 GE DE6 DE5 DF4 GF DF6 DF5)
    rotating
    (ND ND NEF)
    simpleGrading (1 1 1)
    hex (DE6 GE DE0 DE7 DF6 GF DF0 DF7)
    rotating
    (ND ND NEF)
    simpleGrading (1 1 1)

    // block0
    hex (DE0 DE1 RE1 RE0 DF0 DF1 RF1 RF0)
    rotating
    (ND NR NEF)
    simpleGrading (1 1 1)
    // block1
    hex (DE1 DE2 RE2 RE1 DF1 DF2 RF2 RF1)
    rotating
    (ND NR NEF)
    simpleGrading (1 1 1)
    // block2
    hex (DE2 DE3 RE3 RE2 DF2 DF3 RF3 RF2)
    rotating
    (ND NR NEF)
    simpleGrading (1 1 1)
    // block3
    hex (DE3 DE4 RE4 RE3 DF3 DF4 RF4 RF3)
    rotating
    (ND NR NEF)
    simpleGrading (1 1 1)
    // block3
    hex (DE4 DE5 RE5 RE4 DF4 DF5 RF5 RF4)
    rotating
    (ND NR NEF)
    simpleGrading (1 1 1)
    // block3
    hex (DE5 DE6 RE6 RE5 DF5 DF6 RF6 RF5)
    rotating
    (ND NR NEF)
    simpleGrading (1 1 1)
    // block3
    hex (DE6 DE7 RE7 RE6 DF6 DF7 RF7 RF6)
    rotating
    (ND NR NEF)
    simpleGrading (1 1 1)
    // block3
    hex (DE7 DE0 RE0 RE7 DF7 DF0 RF0 RF7)
    rotating
    (ND NR NEF)
    simpleGrading (1 1 1)

    // block0 (D->R, R->R1, NR->NR1)
    hex (RE0 RE1 R1E1 R1E0 RF0 RF1 R1F1 R1F0)
    rotating
    (ND NR1 NEF)
    simpleGrading (1 1 1)
    // block1
    hex (RE1 RE2 R1E2 R1E1 RF1 RF2 R1F2 R1F1)
    rotating
    (ND NR1 NEF)
    simpleGrading (1 1 1)
    // block2
    hex (RE2 RE3 R1E3 R1E2 RF2 RF3 R1F3 R1F2)
    rotating
    (ND NR1 NEF)
    simpleGrading (1 1 1)
    // block3
    hex (RE3 RE4 R1E4 R1E3 RF3 RF4 R1F4 R1F3)
    rotating
    (ND NR1 NEF)
    simpleGrading (1 1 1)
    // block3
    hex (RE4 RE5 R1E5 R1E4 RF4 RF5 R1F5 R1F4)
    rotating
    (ND NR1 NEF)
    simpleGrading (1 1 1)
    // block3
    hex (RE5 RE6 R1E6 R1E5 RF5 RF6 R1F6 R1F5)
    rotating
    (ND NR1 NEF)
    simpleGrading (1 1 1)
    // block3
    hex (RE6 RE7 R1E7 R1E6 RF6 RF7 R1F7 R1F6)
    rotating
    (ND NR1 NEF)
    simpleGrading (1 1 1)
    // block3
    hex (RE7 RE0 R1E0 R1E7 RF7 RF0 R1F0 R1F7)
    rotating
    (ND NR1 NEF)
    simpleGrading (1 1 1)

    // block0 (R->R1, R1->R2, NR1->NR2)
    hex (R1E0 R1E1 R2E1 R2E0 R1F0 R1F1 R2F1 R2F0)
    (ND NR2 NEF)
    simpleGrading (1 1 1)
    // block1
    hex (R1E1 R1E2 R2E2 R2E1 R1F1 R1F2 R2F2 R2F1)
    (ND NR2 NEF)
    simpleGrading (1 1 1)
    // block2
    hex (R1E2 R1E3 R2E3 R2E2 R1F2 R1F3 R2F3 R2F2)
    (ND NR2 NEF)
    simpleGrading (1 1 1)
    // block3
    hex (R1E3 R1E4 R2E4 R2E3 R1F3 R1F4 R2F4 R2F3)
    (ND NR2 NEF)
    simpleGrading (1 1 1)
    // block3
    hex (R1E4 R1E5 R2E5 R2E4 R1F4 R1F5 R2F5 R2F4)
    (ND NR2 NEF)
    simpleGrading (1 1 1)
    // block3
    hex (R1E5 R1E6 R2E6 R2E5 R1F5 R1F6 R2F6 R2F5)
    (ND NR2 NEF)
    simpleGrading (1 1 1)
    // block3
    hex (R1E6 R1E7 R2E7 R2E6 R1F6 R1F7 R2F7 R2F6)
    (ND NR2 NEF)
    simpleGrading (1 1 1)
    // block3
    hex (R1E7 R1E0 R2E0 R2E7 R1F7 R1F0 R2F0 R2F7)
    (ND NR2 NEF)
    simpleGrading (1 1 1)

// NFG 円管6段目 ( E->F, F->G, EF->FG ) 
    // 中心矩形領域（４分割）
    hex (DF0 GF DF2 DF1 DG0 GG DG2 DG1)
    (ND ND NFG)
    simpleGrading (1 1 1)
    hex (DF2 GF DF4 DF3 DG2 GG DG4 DG3)
    (ND ND NFG)
    simpleGrading (1 1 1)
    hex (DF4 GF DF6 DF5 DG4 GG DG6 DG5)
    (ND ND NFG)
    simpleGrading (1 1 1)
    hex (DF6 GF DF0 DF7 DG6 GG DG0 DG7)
    (ND ND NFG)
    simpleGrading (1 1 1)

    // block0
    hex (DF0 DF1 RF1 RF0 DG0 DG1 RG1 RG0)
    (ND NR NFG)
    simpleGrading (1 1 1)
    // block1
    hex (DF1 DF2 RF2 RF1 DG1 DG2 RG2 RG1)
    (ND NR NFG)
    simpleGrading (1 1 1)
    // block2
    hex (DF2 DF3 RF3 RF2 DG2 DG3 RG3 RG2)
    (ND NR NFG)
    simpleGrading (1 1 1)
    // block3
    hex (DF3 DF4 RF4 RF3 DG3 DG4 RG4 RG3)
    (ND NR NFG)
    simpleGrading (1 1 1)
    // block3
    hex (DF4 DF5 RF5 RF4 DG4 DG5 RG5 RG4)
    (ND NR NFG)
    simpleGrading (1 1 1)
    // block3
    hex (DF5 DF6 RF6 RF5 DG5 DG6 RG6 RG5)
    (ND NR NFG)
    simpleGrading (1 1 1)
    // block3
    hex (DF6 DF7 RF7 RF6 DG6 DG7 RG7 RG6)
    (ND NR NFG)
    simpleGrading (1 1 1)
    // block3
    hex (DF7 DF0 RF0 RF7 DG7 DG0 RG0 RG7)
    (ND NR NFG)
    simpleGrading (1 1 1)

    // block0 (D->R, R->R1, NR->NR1)
    hex (RF0 RF1 R1F1 R1F0 RG0 RG1 R1G1 R1G0)
    (ND NR1 NFG)
    simpleGrading (1 1 1)
    // block1
    hex (RF1 RF2 R1F2 R1F1 RG1 RG2 R1G2 R1G1)
    (ND NR1 NFG)
    simpleGrading (1 1 1)
    // block2
    hex (RF2 RF3 R1F3 R1F2 RG2 RG3 R1G3 R1G2)
    (ND NR1 NFG)
    simpleGrading (1 1 1)
    // block3
    hex (RF3 RF4 R1F4 R1F3 RG3 RG4 R1G4 R1G3)
    (ND NR1 NFG)
    simpleGrading (1 1 1)
    // block3
    hex (RF4 RF5 R1F5 R1F4 RG4 RG5 R1G5 R1G4)
    (ND NR1 NFG)
    simpleGrading (1 1 1)
    // block3
    hex (RF5 RF6 R1F6 R1F5 RG5 RG6 R1G6 R1G5)
    (ND NR1 NFG)
    simpleGrading (1 1 1)
    // block3
    hex (RF6 RF7 R1F7 R1F6 RG6 RG7 R1G7 R1G6)
    (ND NR1 NFG)
    simpleGrading (1 1 1)
    // block3
    hex (RF7 RF0 R1F0 R1F7 RG7 RG0 R1G0 R1G7)
    (ND NR1 NFG)
    simpleGrading (1 1 1)

    // block0 (R->R1, R1->R2, NR1->NR2)
    hex (R1F0 R1F1 R2F1 R2F0 R1G0 R1G1 R2G1 R2G0)
    (ND NR2 NFG)
    simpleGrading (1 1 1)
    // block1
    hex (R1F1 R1F2 R2F2 R2F1 R1G1 R1G2 R2G2 R2G1)
    (ND NR2 NFG)
    simpleGrading (1 1 1)
    // block2
    hex (R1F2 R1F3 R2F3 R2F2 R1G2 R1G3 R2G3 R2G2)
    (ND NR2 NFG)
    simpleGrading (1 1 1)
    // block3
    hex (R1F3 R1F4 R2F4 R2F3 R1G3 R1G4 R2G4 R2G3)
    (ND NR2 NFG)
    simpleGrading (1 1 1)
    // block3
    hex (R1F4 R1F5 R2F5 R2F4 R1G4 R1G5 R2G5 R2G4)
    (ND NR2 NFG)
    simpleGrading (1 1 1)
    // block3
    hex (R1F5 R1F6 R2F6 R2F5 R1G5 R1G6 R2G6 R2G5)
    (ND NR2 NFG)
    simpleGrading (1 1 1)
    // block3
    hex (R1F6 R1F7 R2F7 R2F6 R1G6 R1G7 R2G7 R2G6)
    (ND NR2 NFG)
    simpleGrading (1 1 1)
    // block3
    hex (R1F7 R1F0 R2F0 R2F7 R1G7 R1G0 R2G0 R2G7)
    (ND NR2 NFG)
    simpleGrading (1 1 1)

);

edges
(
    arc RA0 RA1 evert(1, 0, LA)
    arc RA1 RA2 evert(1, 1, LA)
    arc RA2 RA3 evert(1, 2, LA)
    arc RA3 RA4 evert(1, 3, LA)
    arc RA4 RA5 evert(1, 4, LA)
    arc RA5 RA6 evert(1, 5, LA)
    arc RA6 RA7 evert(1, 6, LA)
    arc RA7 RA0 evert(1, 7, LA)

    arc RB0 RB1 evert(1, 0, LB)
    arc RB1 RB2 evert(1, 1, LB)
    arc RB2 RB3 evert(1, 2, LB)
    arc RB3 RB4 evert(1, 3, LB)
    arc RB4 RB5 evert(1, 4, LB)
    arc RB5 RB6 evert(1, 5, LB)
    arc RB6 RB7 evert(1, 6, LB)
    arc RB7 RB0 evert(1, 7, LB)

    arc RC0 RC1 evert(1, 0, LC)
    arc RC1 RC2 evert(1, 1, LC)
    arc RC2 RC3 evert(1, 2, LC)
    arc RC3 RC4 evert(1, 3, LC)
    arc RC4 RC5 evert(1, 4, LC)
    arc RC5 RC6 evert(1, 5, LC)
    arc RC6 RC7 evert(1, 6, LC)
    arc RC7 RC0 evert(1, 7, LC)

    arc RD0 RD1 evert(1, 0, LD)
    arc RD1 RD2 evert(1, 1, LD)
    arc RD2 RD3 evert(1, 2, LD)
    arc RD3 RD4 evert(1, 3, LD)
    arc RD4 RD5 evert(1, 4, LD)
    arc RD5 RD6 evert(1, 5, LD)
    arc RD6 RD7 evert(1, 6, LD)
    arc RD7 RD0 evert(1, 7, LD)

    arc RE0 RE1 evert(1, 0, LE)
    arc RE1 RE2 evert(1, 1, LE)
    arc RE2 RE3 evert(1, 2, LE)
    arc RE3 RE4 evert(1, 3, LE)
    arc RE4 RE5 evert(1, 4, LE)
    arc RE5 RE6 evert(1, 5, LE)
    arc RE6 RE7 evert(1, 6, LE)
    arc RE7 RE0 evert(1, 7, LE)

    arc RF0 RF1 evert(1, 0, LF)
    arc RF1 RF2 evert(1, 1, LF)
    arc RF2 RF3 evert(1, 2, LF)
    arc RF3 RF4 evert(1, 3, LF)
    arc RF4 RF5 evert(1, 4, LF)
    arc RF5 RF6 evert(1, 5, LF)
    arc RF6 RF7 evert(1, 6, LF)
    arc RF7 RF0 evert(1, 7, LF)

    arc RG0 RG1 evert(1, 0, LG)
    arc RG1 RG2 evert(1, 1, LG)
    arc RG2 RG3 evert(1, 2, LG)
    arc RG3 RG4 evert(1, 3, LG)
    arc RG4 RG5 evert(1, 4, LG)
    arc RG5 RG6 evert(1, 5, LG)
    arc RG6 RG7 evert(1, 6, LG)
    arc RG7 RG0 evert(1, 7, LG)

    arc R1A0 R1A1 evert(2, 0, LA)
    arc R1A1 R1A2 evert(2, 1, LA)
    arc R1A2 R1A3 evert(2, 2, LA)
    arc R1A3 R1A4 evert(2, 3, LA)
    arc R1A4 R1A5 evert(2, 4, LA)
    arc R1A5 R1A6 evert(2, 5, LA)
    arc R1A6 R1A7 evert(2, 6, LA)
    arc R1A7 R1A0 evert(2, 7, LA)

    arc R1B0 R1B1 evert(2, 0, LB)
    arc R1B1 R1B2 evert(2, 1, LB)
    arc R1B2 R1B3 evert(2, 2, LB)
    arc R1B3 R1B4 evert(2, 3, LB)
    arc R1B4 R1B5 evert(2, 4, LB)
    arc R1B5 R1B6 evert(2, 5, LB)
    arc R1B6 R1B7 evert(2, 6, LB)
    arc R1B7 R1B0 evert(2, 7, LB)

    arc R1C0 R1C1 evert(2, 0, LC)
    arc R1C1 R1C2 evert(2, 1, LC)
    arc R1C2 R1C3 evert(2, 2, LC)
    arc R1C3 R1C4 evert(2, 3, LC)
    arc R1C4 R1C5 evert(2, 4, LC)
    arc R1C5 R1C6 evert(2, 5, LC)
    arc R1C6 R1C7 evert(2, 6, LC)
    arc R1C7 R1C0 evert(2, 7, LC)

    arc R1D0 R1D1 evert(2, 0, LD)
    arc R1D1 R1D2 evert(2, 1, LD)
    arc R1D2 R1D3 evert(2, 2, LD)
    arc R1D3 R1D4 evert(2, 3, LD)
    arc R1D4 R1D5 evert(2, 4, LD)
    arc R1D5 R1D6 evert(2, 5, LD)
    arc R1D6 R1D7 evert(2, 6, LD)
    arc R1D7 R1D0 evert(2, 7, LD)

    arc R1E0 R1E1 evert(2, 0, LE)
    arc R1E1 R1E2 evert(2, 1, LE)
    arc R1E2 R1E3 evert(2, 2, LE)
    arc R1E3 R1E4 evert(2, 3, LE)
    arc R1E4 R1E5 evert(2, 4, LE)
    arc R1E5 R1E6 evert(2, 5, LE)
    arc R1E6 R1E7 evert(2, 6, LE)
    arc R1E7 R1E0 evert(2, 7, LE)

    arc R1F0 R1F1 evert(2, 0, LF)
    arc R1F1 R1F2 evert(2, 1, LF)
    arc R1F2 R1F3 evert(2, 2, LF)
    arc R1F3 R1F4 evert(2, 3, LF)
    arc R1F4 R1F5 evert(2, 4, LF)
    arc R1F5 R1F6 evert(2, 5, LF)
    arc R1F6 R1F7 evert(2, 6, LF)
    arc R1F7 R1F0 evert(2, 7, LF)

    arc R1G0 R1G1 evert(2, 0, LG)
    arc R1G1 R1G2 evert(2, 1, LG)
    arc R1G2 R1G3 evert(2, 2, LG)
    arc R1G3 R1G4 evert(2, 3, LG)
    arc R1G4 R1G5 evert(2, 4, LG)
    arc R1G5 R1G6 evert(2, 5, LG)
    arc R1G6 R1G7 evert(2, 6, LG)
    arc R1G7 R1G0 evert(2, 7, LG)

    arc R2A0 R2A1 evert(3, 0, LA)
    arc R2A1 R2A2 evert(3, 1, LA)
    arc R2A2 R2A3 evert(3, 2, LA)
    arc R2A3 R2A4 evert(3, 3, LA)
    arc R2A4 R2A5 evert(3, 4, LA)
    arc R2A5 R2A6 evert(3, 5, LA)
    arc R2A6 R2A7 evert(3, 6, LA)
    arc R2A7 R2A0 evert(3, 7, LA)

    arc R2B0 R2B1 evert(3, 0, LB)
    arc R2B1 R2B2 evert(3, 1, LB)
    arc R2B2 R2B3 evert(3, 2, LB)
    arc R2B3 R2B4 evert(3, 3, LB)
    arc R2B4 R2B5 evert(3, 4, LB)
    arc R2B5 R2B6 evert(3, 5, LB)
    arc R2B6 R2B7 evert(3, 6, LB)
    arc R2B7 R2B0 evert(3, 7, LB)

    arc R2C0 R2C1 evert(3, 0, LC)
    arc R2C1 R2C2 evert(3, 1, LC)
    arc R2C2 R2C3 evert(3, 2, LC)
    arc R2C3 R2C4 evert(3, 3, LC)
    arc R2C4 R2C5 evert(3, 4, LC)
    arc R2C5 R2C6 evert(3, 5, LC)
    arc R2C6 R2C7 evert(3, 6, LC)
    arc R2C7 R2C0 evert(3, 7, LC)

    arc R2D0 R2D1 evert(3, 0, LD)
    arc R2D1 R2D2 evert(3, 1, LD)
    arc R2D2 R2D3 evert(3, 2, LD)
    arc R2D3 R2D4 evert(3, 3, LD)
    arc R2D4 R2D5 evert(3, 4, LD)
    arc R2D5 R2D6 evert(3, 5, LD)
    arc R2D6 R2D7 evert(3, 6, LD)
    arc R2D7 R2D0 evert(3, 7, LD)

    arc R2E0 R2E1 evert(3, 0, LE)
    arc R2E1 R2E2 evert(3, 1, LE)
    arc R2E2 R2E3 evert(3, 2, LE)
    arc R2E3 R2E4 evert(3, 3, LE)
    arc R2E4 R2E5 evert(3, 4, LE)
    arc R2E5 R2E6 evert(3, 5, LE)
    arc R2E6 R2E7 evert(3, 6, LE)
    arc R2E7 R2E0 evert(3, 7, LE)

    arc R2F0 R2F1 evert(3, 0, LF)
    arc R2F1 R2F2 evert(3, 1, LF)
    arc R2F2 R2F3 evert(3, 2, LF)
    arc R2F3 R2F4 evert(3, 3, LF)
    arc R2F4 R2F5 evert(3, 4, LF)
    arc R2F5 R2F6 evert(3, 5, LF)
    arc R2F6 R2F7 evert(3, 6, LF)
    arc R2F7 R2F0 evert(3, 7, LF)

    arc R2G0 R2G1 evert(3, 0, LG)
    arc R2G1 R2G2 evert(3, 1, LG)
    arc R2G2 R2G3 evert(3, 2, LG)
    arc R2G3 R2G4 evert(3, 3, LG)
    arc R2G4 R2G5 evert(3, 4, LG)
    arc R2G5 R2G6 evert(3, 5, LG)
    arc R2G6 R2G7 evert(3, 6, LG)
    arc R2G7 R2G0 evert(3, 7, LG)
);

patches
(
);

smoother
{
    elemTransformParameter    0.666; // Geometric transformation parameter.
    maxGETMeIter              1000; // Smoothing stop after 1000 iterations.
    improvementTolerance      1e-4; // Mean cycle stop when improvement is below 1e-4.
    qMeanRelaxationTable      (1 0.25 0.125 0); // !Last value is always 0.
    qMinRelaxationTable       (0.1 0.05 0.01 0); 
    maxIneffectiveIteration   5; // Max no min cycle improvement.

    features
    {
        featureAngle          30; // Feature edge detection.
        minEdgeForFeature     10;
    }
};

// ************************************************************************* //
